---
layout: default
title: Users Documentation and Reference
toc: false
---

Index to basic users documentation.

## Basic Operations and Configuration

 1. [Getting Started](basic/gettingstarted.html)
 1. [Configuration Guide](basic/configuration.html)
 1. [Message Flow](basic/messageflow.html)
 1. [Network Partitioning using Subcollectives](basic/subcollectives.html)
 1. [Message Format](basic/messageformat.html)

### User Interface

 1. [Using MCollective Command Line Applications](basic/basic_cli_usage.html)
 1. [Node Reports](ui/nodereports.html)
 1. [CLI Filters](ui/filters.html)

### Integration

 1. [Using with Puppet](integration/puppet.html)
 1. [ActiveMQ Security](integration/activemq_security.html)
 1. [ActiveMQ SSL](integration/activemq_ssl.html)
 1. [ActiveMQ Clusters](integration/activemq_clusters.html)
 1. [ActiveMQ Connector](plugins/connector_activemq.html)
 1. [RabbitMQ Connector](plugins/connector_rabbitmq.html)

### Plugin Types

 1. [Data Plugins](plugins/data.html)
 1. [Discovery Plugins](plugins/discovery.html)
 1. [Result Aggregation Plugins](plugins/aggregate.html)
 1. [The single application plugin system](plugins/application.html)
 1. [Registration](plugins/registration.html)
 1. [Fact Source Plugins](plugins/facts.html)
 1. [Validator Plugins](plugins/validator.html)

### Plugins

 1. [The _rpcutil_ helper Agent](plugins/rpcutil.html)
 1. [AES+RSA based Security Plugin](plugins/security_aes.html)
 1. [OpenSSL based Security Plugin](plugins/security_ssl.html)
 1. [Stomp Connector](plugins/connector_stomp.html)
 1. [ActiveMQ Connector](plugins/connector_activemq.html)
 1. [RabbitMQ Connector](plugins/connector_rabbitmq.html)
 1. [User Contributed Plugins](plugin_directory/)

### Development

 1. [Release Tasks](development/releasetasks.html)
 1. [EC2 Demo Creation](development/ec2_demo.html)
